/**
 * All My Tweets
 * © 2016 Airtight Interactive.
 * www.airtight.cc
 * v1.1.0
 */

var _loadedCount;
var _screenName;
var _hideRetweets;
var _hideReplies;
var _maxId;
var _req;

$(document).ready(function() {

	$("#results").hide();

	$('#input_form').submit(function() {
		getTweets();
		return false;
	});

	$('#replies').click(function () {

		if (!$("#input_form").is(":visible")){ 
			getTweets();
		}
	});
	$('#retweets').click(function () {
		if (!$("#input_form").is(":visible")){ 
			getTweets();
		}
	});

	$('#change-user-btn').click(function () {

		//reset UI
		event.preventDefault();
		$("#input_form").show();
		$("#results").hide();
		$("#change-user-btn").hide();
		$("#profile_img").hide();
		$("#input_name").val("");
		$("#tweets ul").empty();
		$('#replies').prop('checked', false);
		$('#retweets').prop('checked', false);
		$(".intro").show();

		if (_req) _req.abort();
	});


});

function getTweets() {

	var SCRIPT_REGEX = /<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi;
	_screenName = $("#input_name").val().replace(SCRIPT_REGEX, "");
	_screenName = _screenName.replace("@", "");

	if (_req) _req.abort();

	if (_screenName === "") return;

	$("#user_name").html(_screenName);

	$("#input_form").hide();
	$("#results").show();
	$("#change-user-btn").show();
	$(".intro").hide();

	//get profile img
	var qurl = "get_icon.php?screen_name=" + _screenName ;
	$.get( qurl, function(data) {
		data_obj = jQuery.parseJSON(data);

		if (data_obj.errors){
			$("#status").text("User not found");
			$("#loader").hide();
			$("#profile_img").hide();
			return;
		}else{
			//only get tweets if user found
			getTweetPage();
		}

		$("img#profile_img").attr("src", data_obj[0].profile_image_url);
		$("#profile_img").show();
	});

	$("#tweets ul").empty();

	$("#status").text("loading tweets");
	$("#loader").show();

	_hideReplies =$("#replies").is(":checked");
	_hideRetweets =$("#retweets").is(":checked");
	_loadedCount = 0;
	_maxId = -1;

	
}

function getTweetPage() {

	var maxidStr = _maxId > 0 ? "&max_id=" + _maxId : ""  ;

	var qurl = "get_tweets.php?count=100&screen_name=" + _screenName + maxidStr + "&include_rts=" + !_hideRetweets + "&exclude_replies=" + _hideReplies;
	
	_req = $.get( qurl, function(data) {

		data_obj = jQuery.parseJSON(data);

		if(data_obj.error) {
			console.log("ERROR: " + data_obj.error);
			$("#status").text(data_obj.error);
			$("#loader").hide();
			return;
		}

		//ignore duplicate first item when using max_id
		if (data_obj.length > 0 && data_obj[0].id == _maxId){
			data_obj.shift();
		}

		//render tweets
		$.each(data_obj, function(i, item) {
			//save maxId
			_maxId = item.id;
			$("#tweets ul").append("<li>" + item.text + " <a target='_blank' href='https://twitter.com/#!/" + _screenName + "/status/" + item.id_str + "'> <span class='created_at'>" + format_time(item.created_at) + "</span> <img src='css/extlink.png'></img></a></li>");
		});

		$('#tweets ul').linkify({target: '_blank'});

		if(data_obj.length > 1) {
			_loadedCount += data_obj.length;
			getTweetPage();
			$("#status").text("loaded " + _loadedCount + " tweets");
		} else {
			//done
			$("#loader").hide();
		}
	});
}

function format_time(time_value) {
	var values = time_value.split(" ");
	time_value = values[1] + " " + values[2] + ", " + values[5];
	return time_value;
}